/**
 * GazelleCrossValidatorType.java
 *
 * File generated from the XValidator4::GazelleCrossValidatorType uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.Lob;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.PostLoad;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;
import javax.persistence.UniqueConstraint;
import net.ihe.gazelle.preferences.PreferenceService;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;

import net.ihe.gazelle.hql.FilterLabel;
import net.ihe.gazelle.xvalidation.core.report.XSDValidation;
import net.ihe.gazelle.xvalidation.core.utils.XMLValidation;

import org.hibernate.annotations.Type;
import org.jboss.seam.security.Identity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Node;

// End of user code

/**
 * Description of the class GazelleCrossValidatorType.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "GazelleCrossValidator_._type", propOrder = { "description", "validatedObjects", "validatorParents",
		"configuration", "rules", "affinityDomain", "lastModified", "lastModifier", "name", "status", "version", "oid" })
@XmlRootElement(name = "GazelleCrossValidator")
@Entity
@Table(name = "xval_cross_validator", schema = "public")
@SequenceGenerator(name = "xval_cross_validator_sequence", sequenceName = "xval_cross_validator_id_seq", allocationSize = 1)
public class GazelleCrossValidatorType implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 2807567514133996881L;

	private static Logger log = LoggerFactory.getLogger(GazelleCrossValidatorType.class);
	public static final String DEV_SUFFIX = "-um";
	public static final String COPY_SUFFIX = "_COPY";


	@Id
	@GeneratedValue(generator = "xval_cross_validator_sequence", strategy = GenerationType.SEQUENCE)
	@Column(name = "id", unique = true, nullable = false)
	@XmlTransient
	private Integer id;

	@XmlElement(name = "Description", required = true)
	@Type(type = "text")
	@Lob
	private String description;

	@XmlElement(name = "ValidatedObject")
	@OneToMany(fetch = FetchType.EAGER, cascade = {CascadeType.ALL }, mappedBy = "gazelleCrossValidator", targetEntity = ValidatorInput.class)
	private List<ValidatorInput> validatedObjects;

	@XmlElement(name = "Rule", required = true)
	@OneToMany(cascade = { CascadeType.ALL }, targetEntity = Rule.class, mappedBy = "gazelleCrossValidator")
	private List<Rule> rules;

	@XmlElement(name = "ValidatorParent")
	@ManyToMany(cascade={CascadeType.MERGE, CascadeType.PERSIST})
	@JoinTable(name = "xval_cross_validator_parent", inverseJoinColumns = @JoinColumn(name = "validator_parent_id"),
			joinColumns = @JoinColumn(name = "validator_id"),
			uniqueConstraints = @UniqueConstraint(columnNames = {"validator_parent_id", "validator_id" }))
	private List<CrossValidatorReference> validatorParents;

	@XmlAttribute(name = "affinityDomain")
	private String affinityDomain;

	@XmlAttribute(name = "lastModified", required = true)
	@XmlSchemaType(name = "dateTime")
	@Transient
	private javax.xml.datatype.XMLGregorianCalendar lastModified;

	@XmlTransient
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "last_modified_date")
	private Date lastModifiedDate;

	@Column(name = "last_modifier")
	@XmlAttribute(name = "lastModifier", required = true)
	private String lastModifier;

	@XmlAttribute(name = "name", required = true)
	private String name;

	@XmlAttribute(name = "status", required = true)
	private Status status;

	@XmlAttribute(name = "version", required = true)
	private String version;

	@XmlAttribute(name = "oid", required = true)
	private String oid = "Not available";

	@XmlElement(name = "Configuration")
	@OneToOne(cascade = { CascadeType.ALL }, mappedBy = "validator")
	private ValidatorConfiguration configuration;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	@PreUpdate
	@PrePersist
	public void onChange() {
		lastModifiedDate = new Date();
		lastModifier = Identity.instance().getCredentials().getUsername();
	}

	/**
	 * Return description.
	 *
	 * @return description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Set a value to attribute description.
	 *
	 * @param description
	 *            .
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * Return validatedObjects.
	 *
	 * @return validatedObjects
	 */
	public List<ValidatorInput> getValidatedObjects() {
		if (validatedObjects == null) {
			validatedObjects = new ArrayList<ValidatorInput>();
		}
		return validatedObjects;
	}

	/**
	 * Set a value to attribute validatedObjects.
	 *
	 * @param validatedObjects
	 *            .
	 */
	public void setValidatedObjects(List<ValidatorInput> validatedObjects) {
		this.validatedObjects = validatedObjects;
	}

	/**
	 * Add a validatedObjects to the validatedObjects collection.
	 *
	 * @param validatedObjectsElement
	 *            Element to add.
	 */
	public void addValidatedObjects(ValidatorInput validatedObjectsElement) {
		this.getValidatedObjects().add(validatedObjectsElement);
	}

	/**
	 * Remove a validatedObjects to the validatedObjects collection.
	 *
	 * @param validatedObjectsElement
	 *            Element to remove
	 */
	public void removeValidatedObjects(ValidatorInput validatedObjectsElement) {
		this.getValidatedObjects().remove(validatedObjectsElement);
	}

	/**
	 * Return rule.
	 *
	 * @return rule
	 */
	public List<Rule> getRules() {
		if (rules == null) {
			rules = new ArrayList<Rule>();
		}
		return rules;
	}

	/**
	 * Set a value to attribute rule.
	 *
	 * @param rule
	 *            .
	 */
	public void setRules(List<Rule> rule) {
		this.rules = rule;
	}

	/**
	 * Add a rule to the rule collection.
	 *
	 * @param ruleElement
	 *            Element to add.
	 */
	public void addRule(Rule ruleElement) {
		this.getRules().add(ruleElement);
	}

	/**
	 * Remove a rule to the rule collection.
	 *
	 * @param ruleElement
	 *            Element to remove
	 */
	public void removeRule(Rule ruleElement) {
		this.getRules().remove(ruleElement);
	}

	/**
	 * Return validatorParent.
	 *
	 * @return validatorParent
	 */
	public List<CrossValidatorReference> getValidatorParents() {
		if (validatorParents == null) {
			validatorParents = new ArrayList<CrossValidatorReference>();
		}
		return validatorParents;
	}

	/**
	 * Set a value to attribute validatorParent.
	 *
	 * @param validatorParent
	 *            .
	 */
	public void setValidatorParents(List<CrossValidatorReference> validatorParent) {
		this.validatorParents = validatorParent;
	}

	/**
	 * Add a validatorParent to the validatorParent collection.
	 *
	 * @param validatorParentElement
	 *            Element to add.
	 */
	public void addValidatorParent(CrossValidatorReference validatorParentElement) {
		if (!getValidatorParents().contains(validatorParentElement)) {
			this.getValidatorParents().add(validatorParentElement);
		}
	}

	/**
	 * Remove a validatorParent to the validatorParent collection.
	 *
	 * @param validatorParentElement
	 *            Element to remove
	 */
	public void removeValidatorParent(CrossValidatorReference validatorParentElement) {
		this.getValidatorParents().remove(validatorParentElement);
	}

	/**
	 * Return affinityDomain.
	 *
	 * @return affinityDomain
	 */
	public String getAffinityDomain() {
		return affinityDomain;
	}

	/**
	 * Set a value to attribute affinityDomain.
	 *
	 * @param affinityDomain
	 *            .
	 */
	public void setAffinityDomain(String affinityDomain) {
		this.affinityDomain = affinityDomain;
	}

	/**
	 * Return lastModifiedDate.
	 *
	 * @return lastModifiedDate
	 */
	public javax.xml.datatype.XMLGregorianCalendar getLastModified() {
		return lastModified;
	}

	@PostLoad
	public void setLastModified() {
		if (this.lastModifiedDate != null) {
			GregorianCalendar calendar = new GregorianCalendar();
			calendar.setTime(this.lastModifiedDate);
			try {
				this.lastModified = DatatypeFactory.newInstance().newXMLGregorianCalendar(calendar);
			} catch (DatatypeConfigurationException e) {
				log.error(e.getMessage(), e);
			}
		} else {
			this.lastModified = null;
		}
	}

	/**
	 * Set a value to attribute lastModifiedDate.
	 *
	 * @param lastModifiedDate
	 *            .
	 */
	public void setLastModified(javax.xml.datatype.XMLGregorianCalendar lastModifiedDate) {
		this.lastModified = lastModifiedDate;
		setLastModifiedDate(this.lastModified.toGregorianCalendar().getTime());
	}

	public void setLastModifiedDate(javax.xml.datatype.XMLGregorianCalendar lastModified) {
		if (lastModified != null) {
			setLastModifiedDate(lastModified.toGregorianCalendar().getTime());
		}
	}

	/**
	 * Return lastModifier.
	 *
	 * @return lastModifier
	 */
	public String getLastModifier() {
		return lastModifier;
	}

	/**
	 * Set a value to attribute lastModifier.
	 *
	 * @param lastModifier
	 *            .
	 */
	public void setLastModifier(String lastModifier) {
		this.lastModifier = lastModifier;
	}

	/**
	 * Return name.
	 *
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Set a value to attribute name.
	 *
	 * @param name
	 *            .
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Return status.
	 *
	 * @return status
	 */
	public Status getStatus() {
		return status;
	}

	/**
	 * Set a value to attribute status.
	 *
	 * @param status
	 *            .
	 */
	public void setStatus(Status status) {
		this.status = status;
	}

	/**
	 * Return version.
	 *
	 * @return version
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * Set a value to attribute version.
	 *
	 * @param version
	 *            .
	 */
	public void setVersion(String version) {
		if (version != null) {
			this.version = version.trim();
		} else {
			this.version = null;
		}
	}


	/**
	 * Return oid.
	 *
	 * @return oid
	 */
	public String getOid() {
		return oid;
	}

	/**
	 * Set a value to attribute oid.
	 *
	 * @param id
	 *            .
	 */
	public void setOid(Integer id) {


		if (this.id != null) {
			String root = PreferenceService.getString("x_validator_root_oid");
			this.oid = root + id;
		}
		else {
			this.oid=null;
		}
	}


	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "GazelleCrossValidator", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public Date getLastModifiedDate() {
		return lastModifiedDate;
	}

	public void setLastModifiedDate(Date lastModifiedDate) {
		this.lastModifiedDate = lastModifiedDate;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public ValidatorConfiguration getConfiguration() {
		if (this.configuration == null) {
			this.configuration = new ValidatorConfiguration(this);
		}
		return configuration;
	}

	public void setConfiguration(ValidatorConfiguration configuration) {
		this.configuration = configuration;
	}

	@FilterLabel
	public String getLabelForFilter() {
		return this.name + " - " + this.affinityDomain;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + ((affinityDomain == null) ? 0 : affinityDomain.hashCode());
		result = (prime * result) + ((name == null) ? 0 : name.hashCode());
		result = (prime * result) + ((version == null) ? 0 : version.hashCode());
		result = (prime * result) + ((oid == null) ? 0 : oid.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		GazelleCrossValidatorType other = (GazelleCrossValidatorType) obj;
		if (affinityDomain == null) {
			if (other.affinityDomain != null) {
				return false;
			}
		} else if (!affinityDomain.equals(other.affinityDomain)) {
			return false;
		}
		if (name == null) {
			if (other.name != null) {
				return false;
			}
		} else if (!name.equals(other.name)) {
			return false;
		}
		if (version == null) {
			if (other.version != null) {
				return false;
			}
		} else if (!version.equals(other.version)) {
			return false;
		}
		if (oid == null) {
			if (other.oid != null) {
				return false;
			}
		} else if (!oid.equals(other.oid)) {
			return false;
		}
		return true;
	}

	public static XSDValidation validateXmlFile(String filename) throws IOException {
		File validatorFile = new File(filename);
		return XMLValidation.validateXValidatorFile(validatorFile);
	}

	public boolean isAvailable() {
		return Status.AVAILABLE.equals(status);
	}

	public boolean isDeprecated() {
		return Status.DEPRECATED.equals(status);
	}

	public boolean isUnderDevelopment() {
		return Status.UNDERDEV.equals(status);
	}

	public boolean isUnderMaintenance() {
		return Status.MAINTENANCE.equals(status);
	}

	public String getFilenameForArchive() {
		String correctedName = name.replace(' ', '_');
		correctedName = correctedName.replace('/', '_');
		correctedName = correctedName.replace('*', 's');
		StringBuilder filename = new StringBuilder(correctedName);
		filename.append('-');
		filename.append(affinityDomain.replace(' ', '_'));
		filename.append('-');
		filename.append(version);
		filename.append(".xml");
		return filename.toString();
	}

	public boolean isEditable() {
		return isUnderDevelopment() || isUnderMaintenance();
	}

	public String getAssertionManagerUrl() {
		return getConfiguration().getAssertionManagerUrl();
	}
	public void setAssertionManagerUrl(String assertionManagerUrl) {
		getConfiguration().setAssertionManagerUrl(assertionManagerUrl);
	}


	public DICOMLibrary getDicomLibrary() {
		return getConfiguration().getDicomLibrary();
	}

	public void setDicomLibrary(DICOMLibrary dicomLibrary) {
		getConfiguration().setDicomLibrary(dicomLibrary);
	}

}